#version 430


in vec3 position;
in vec3 normal;

uniform vec3 cameraPosition;
uniform mat4 MVP;
uniform mat4 model;

const vec3 lightPosition = vec3(-2.0f, 3.0f, -2.0f);
const float tiling = 1;

out vec4 clipSpace;
out vec2 textureCoords;
out vec4 vertexColor;
out vec3 toCameraVector;
out vec3 fromLightVector;
out vec3 camPos;
out vec3 vertPos;

void main() 
{
	vertPos=position;
	camPos=cameraPosition;
	vec4 worldPosition = model *  vec4(position.x, position.y, position.z, 1.0);
	clipSpace =  MVP * vec4(position.x, position.y, position.z, 1.0);
	gl_Position=clipSpace;

	float distToCamera = max(0.0, length(gl_Position) - 2.0f);
	float ratio = distToCamera / 8.0f;
	vertexColor = vec4(0.92f, 0.90f, 1.0f,1.0f);
	vertexColor.r = min(ratio, 1);

	textureCoords =  vec2(position.x/2.0 + 0.5, position.z/2.0 + 0.5)*tiling;
	toCameraVector = cameraPosition - worldPosition.xyz;
	fromLightVector = worldPosition.xyz - lightPosition;

	
}