#version 430 core

in vec3 fragmentPosition;
in vec3 fragmentNormal;
in vec4 ShadowCoord;
in vec2 fragmentUV;
in mediump vec4 vertexColor;

layout(location = 0) out vec4 fragColor;

//uniform sampler2D shadowMap; //ohne PCF
uniform vec3 cameraPosition;
uniform sampler2DShadow shadowMap; //mit PCF
uniform sampler2D texHigh;
uniform sampler2D texLow;

void main()
{
	if(length(cameraPosition-fragmentPosition)>7 || length(cameraPosition-fragmentPosition)<-7 ){discard;}
	//ohne PCF
	
	/*
	vec2 sm_uvs = ShadowCoord.xy / ShadowCoord.w;
	float depth_p = ShadowCoord.z / ShadowCoord.w;
	float depth_c = texture(shadowMap, sm_uvs).r;
	float shadowMult = (depth_c < depth_p) ? 0.8 : 1.0;
	*/
	//shadowMult=shadowMult*10;

	//mit PCF
	float shadowMult = textureProj(shadowMap, ShadowCoord);
	/*
	vec2 sm_uvs = ShadowCoord.xy / ShadowCoord.w;
	float depth_p = ShadowCoord.z / ShadowCoord.w;
	float depth_c = texture(sampler2D(shadowMap), sm_uvs).r;
	if(depth_p-depth_c > depth_c/2) shadowMult=1.0;
	*/
	//ambient
	float lightMult=0.3;

	//diffuse
	vec3 lightPos=vec3(0, 3, 0);

	vec3 lightDir=normalize(lightPos-fragmentPosition);
	float diff = + max(dot(normalize(fragmentNormal), lightDir), 0.0);
	lightMult = lightMult + diff;

	//specular
	/*
	vec3 viewDir= normalize(cameraPosition - fragmentPosition);
	vec3 reflectDir = reflect(-lightDir, fragmentNormal);  
	float spec = pow(max(dot(viewDir, reflectDir), 0.0), 32);
	lightMult = lightMult + spec;
	*/


	vec3 heightColor = shadowMult * lightMult * vec3(0.3+0.4*(fragmentPosition.y/1.8),0.25+0.3*(fragmentPosition.y/2),0.0+0.3*(fragmentPosition.y/1.5));
	
	vec4 textureHigh = texture(texHigh, fragmentUV).rgba;
	textureHigh.a = 0.8;
	vec4 textureLow = texture(texLow, fragmentUV).rgba;
	textureLow.a = 0.5;

	// zwischen den beiden Texturen interpolieren
	vec4 combinedTextureColor = vec4(mix(textureLow.rgba,textureHigh.rgba,fragmentPosition.y/2)); 
	
	// zwischen Hoehenbedingert Farbe und Texturfarbe interpolieren
	vec4 finalColor = vec4(mix(vec4(heightColor.rgb,1.0f),combinedTextureColor.rgba,0.8)); 

	// mit Nebel interpolieren
	fragColor = mix(finalColor.rgba,vec4(0.92f, 0.90f, 1.0f,1.0f).rgba,vertexColor.r);
	fragColor.a=1.0f;

}