#version 430

in vec3 position;
in vec3 normal;
in vec2 uv;
out vec2 fragmentUV;
out vec3 fragmentPosition;
out vec3 fragmentNormal;
out vec4 ShadowCoord;

const vec4 _fogColor= vec4(0.92f, 0.90f, 1.0f, 1.0f);
out mediump vec4 vertexColor;
	
uniform mat4 MVP;
uniform mat4 DepthBiasMVP;
uniform vec4 plane;

void main() 
{
	fragmentUV=uv;	
	fragmentPosition = position;
	gl_Position = MVP * vec4(position, 1.0f);
	gl_ClipDistance[0]= dot(vec4(position, 1.0f),plane);

	ShadowCoord = DepthBiasMVP * vec4(position, 1.0f);

	float distToCamera = max(0.0, length(gl_Position) - 2.0f);
	float ratio = distToCamera / 8.0f;
	vertexColor = vec4(0.92f, 0.90f, 1.0f,1.0f);
	
	vertexColor.r = min(ratio, 1);

	fragmentNormal = normal;

}